# WT-Systeme Frontend

- new setup for production development

## getting started

```
docker-compose up

./bin/go-to-node-container.sh

npm install
```

## app url

http://localhost:3000/


### run unit tests

when inside container, run:
```
npm run test:unit
```

### linting

when inside container, run:
```
npm run lint
```


## resources

### VueJS 3
- https://v3.vuejs.org/guide/introduction.html

### Typescript
- https://www.typescriptlang.org/
- https://v3.vuejs.org/guide/typescript-support.html

### OpenLayers
- https://vue3openlayers.netlify.app/
- https://openlayers.org/en/latest/apidoc/

### proj4
- http://proj4js.org/
- https://epsg.io/

### Plotly-JS
- https://plotly.com/javascript/
- Timeseries examples: https://plotly.com/javascript/configuration-options/
- Config: https://github.com/plotly/plotly.js/blob/master/src/plot_api/plot_config.js
- Translation: https://github.com/plotly/react-plotly.js/issues/99
- two y-axis: https://plotly.com/javascript/multiple-axes/

### shapefiles
- https://github.com/calvinmetcalf/shapefile-js

### VueTreeSelect
- https://github.com/megafetis/vue3-treeselect
- https://vue-treeselect.js.org

### Bulma CSS (responsive Design)
- https://bulma.io/