#!/usr/bin/env bash
set -e
DIR_SCRIPT="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

#
# Customize Image/Tag here
#

TAG_NAME=2.2.0

IMAGE_NAME="git.ufz.de:4567/rdm/wt-systeme/ufz-gdi/frost:${TAG_NAME}"

#
# Pull
#

docker pull "fraunhoferiosb/frost-server:${TAG_NAME}"

docker image tag "fraunhoferiosb/frost-server:${TAG_NAME}" ${IMAGE_NAME}

#
# Push
#
echo
echo "Image in die Registry pushen? [y|N]"
echo "-> ${IMAGE_NAME}"
read -n 1 YESNO
if [ "${YESNO}" == "y" ]; then
    docker push "${IMAGE_NAME}"
fi
