
const webpack = require('webpack');

module.exports = {
  configureWebpack: {
    mode: process.env.NODE_ENV === 'production' ? 'production' : 'development',
    devServer: {
       client: false,
       webSocketServer: false,
       allowedHosts: [
         'web.app.ufz.de'
       ]
    },
    plugins: [
        new webpack.ProvidePlugin({
            Buffer: ['buffer', 'Buffer'],
        })
    ],
    module: {
        rules: [
          {
            test: /\.png$/,
            type: 'asset/resource',
          }
        ]
    }
  },
  lintOnSave: process.env.NODE_ENV !== 'production',
  productionSourceMap: process.env.NODE_ENV !== 'production',
  publicPath: '/' + process.env.VUE_APP_ROUTE + '/'
}